
var fs = require("fs");

module.exports = class SavableData {
  constructor()
  {
      this.path="null";
      this.exclude=[];
  }

  load(path)
  {

    if(path!=undefined) this.path=path;
    try{

      var str = fs.readFileSync(this.path);
      var obj = JSON.parse(str);

      if(obj!=null) Object.assign(this, obj);
    }catch(e)
    {

    }

    return this;
  }

  save(p)
  {
    if( p!=undefined ) this.path=p;
    fs.writeFileSync(this.path, this.toString());
  }

  toString()
  {
    return JSON.stringify(this, null, 2);
  }

  exportToString()
  {
    var obj = {};
    Object.assign(obj, this);
    for(var i=0; i<this.exclude.length; i++)
      delete obj[this.exclude[i]];
    delete this.path;
    delete this.exclude;

    return JSON.stringify(obj, null, 2);
  }

}
